#!/usr/bin/perl -s
#
# makeCollage.pl - Jim Bumgardner
#

use Image::Magick;

$photolist = shift;
$collageName = shift;
die "makeCollage.pl [-big] <photolist_file> [collagename]\n" if !$photolist;

$collageName = $photolist if !$collageName;
$collageName =~ s/\.ph// if $collageName =~ /\.ph$/;

$photolist .= '.ph' if !($photolist =~ /\./);

require "$photolist";

($outW,$outH) = (1024 * ($big? 2 : 1), 768 * ($big? 2 : 1));

$outimage = Image::Magick->new;
$outimage->Set(size=>"${outW}x${outH}");
$outimage->Read('xc:black');

$dirname = $photolist;
$dirname =~ s/\.ph// if $dirname =~ /\.ph$/;

$suffix = $big? '' : '_t';

$n = 0;

foreach $photo (@photos)
{
  $fnam = "$dirname/$photo->{id}$suffix.jpg";
  $img = Image::Magick->new;
  $err = $img->Read($fnam);
  die "Problem reading $fnam: $err" if $err;

  $img->Resize(width=>'200') if $big;

  ($w, $h) = $img->Get('width','height');

  # this code gives the image a random rotation & opacity
  # the mask prevents the bounding rectangle on the rotated image
  # from painting over the images underneath
  $rot = rand()*90-45;
  $v = int(rand()*256);
  $mcolor = sprintf '#%02x%02x%02x', $v, $v, $v;
  $mask = Image::Magick->new;
  $mask->Set(size=>"${w}x${h}"); # worked okay at 10000x10000
  
  $mask->Read("xc:$mcolor");
  $img->Rotate(degrees=>$rot,color=>'black');
  $mask->Rotate(degrees=>$rot,color=>'black');

  ($w, $h) = $img->Get('width','height');
  $x = rand()*($outW-$w);
  $y = rand()*($outH-$h);

  $outimage->Composite(image=>$img, mask=>$mask, x=>$x, y=>$y);
  undef $img;
  undef $mask;
  print "$n...\n" if ++$n % 100 == 0;
}

$outimage->Write("collage$suffix.png");

# done
